diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
new file mode 100644
index 000000000..dea7bdc18
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
@@ -0,0 +1,324 @@
+package net.minecraft.core.entity.animal;
+
+import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.Global;
+import net.minecraft.core.WeightedRandomBag;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.MobFlying;
+import net.minecraft.core.entity.SkinVariantList;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.Map;
+import java.util.Set;
+import java.util.function.Supplier;
+
+public class MobButterfly extends MobFlying implements Creature {
+    public static final Map<Integer, ButterflyEntry> colorEntries = new HashMap<>();
+
+    public static final int DATA_COLOR_ID = 16;
+
+    public static final ButterflyEntry COLOR_BLUE;
+    public static final ButterflyEntry COLOR_ORANGE;
+    public static final ButterflyEntry COLOR_PINK;
+    public static final ButterflyEntry COLOR_SILVER;
+
+    public static ButterflyEntry addEntry(int id, String name, double weight, Supplier<Item> jarItem, Biome ... allowedBiomes) {
+        assert id >= 0 && id <= 0xFF : "ID is outside valid range!";
+        ButterflyEntry entry = new ButterflyEntry(id, name, weight, jarItem, allowedBiomes);
+        colorEntries.put(id, entry);
+        return entry;
+    }
+
+    static {
+        COLOR_BLUE = addEntry(0, "blue", 1, () -> Items.JAR_BUTTERFLY_BLUE);
+        COLOR_ORANGE = addEntry(1, "orange", 1, () -> Items.JAR_BUTTERFLY_ORANGE);
+        COLOR_PINK = addEntry(2, "pink", 1, () -> Items.JAR_BUTTERFLY_PINK);
+        COLOR_SILVER = addEntry(3, "silver", 1, () -> Items.JAR_BUTTERFLY_SILVER);
+    }
+
+    public int courseChangeCooldown = 0;
+    public double waypointX = 0;
+    public double waypointY = 0;
+    public double waypointZ = 0;
+
+    public MobButterfly(World world) {
+        super(world);
+        textureIdentifier = new NamespaceID("minecraft", "butterfly");
+        setSize(0.5f, 0.5f);
+    }
+
+    @Override
+    protected void defineSynchedData() {
+        super.defineSynchedData();
+        entityData.define(DATA_COLOR_ID, (byte)0, Byte.class);
+    }
+
+    @Override
+    protected boolean makeStepSound()
+    {
+        return false;
+    }
+
+    @Override
+    public boolean isPickable() {
+        return false;
+    }
+
+    @Override
+    public boolean isPushable() {
+        return false;
+    }
+
+    @Override
+    public boolean isSelectable() {
+        return false;
+    }
+
+    @Override
+    public String getLivingSound()
+    {
+        return "";
+    }
+
+    @Override
+    protected String getHurtSound()
+    {
+        return "";
+    }
+
+    @Override
+    protected String getDeathSound()
+    {
+        return "";
+    }
+
+    @Override
+    public boolean canRide() {
+        return false;
+    }
+
+    @Override
+    public void push(Entity entity) {
+    }
+
+    @Override
+    public boolean hurt(Entity attacker, int i, DamageType type)
+    {
+        if (type == null || type == DamageType.GENERIC || type == DamageType.BLAST || type == DamageType.FIRE || type == DamageType.DROWN) {
+            return super.hurt(attacker, i, type);
+        }
+        return false;
+    }
+
+
+    @Override
+    public void spawnInit() {
+        super.spawnInit();
+
+        Biome currentBiome = world.getBlockBiome(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
+
+        WeightedRandomBag<ButterflyEntry> colorBag = new WeightedRandomBag<>();
+        for (ButterflyEntry entry : colorEntries.values()) {
+            if (entry.isBiomeAllowed(currentBiome)) {
+                colorBag.addEntry(entry, entry.weight);
+            }
+        }
+
+        ButterflyEntry entry = colorBag.getRandom();
+        if (entry == null) entry = COLOR_BLUE;
+        setColor(entry.id);
+    }
+
+    private boolean isCourseTraversable(double waypointX, double waypointY, double waypointZ, double distanceFromEntity)
+    {
+
+        double dx = (waypointX - x) / distanceFromEntity;
+        double dy = (waypointY - y) / distanceFromEntity;
+        double dz = (waypointZ - z) / distanceFromEntity;
+        AABB entityBB = bb.copy();
+        for(int i = 0; (double)i < distanceFromEntity; i++)
+        {
+            entityBB.move(dx, dy, dz);
+            if(!world.getCubes(this, entityBB).isEmpty())
+            {
+                return false;
+            }
+        }
+
+        return true;
+    }
+
+    @Override
+    protected void updateAI()
+    {
+        entityAge++;
+        tryToDespawn();
+
+        Player closestPlayer = world.getClosestPlayerToEntity(this, 2);
+        if (closestPlayer != null) {
+            double distanceX = closestPlayer.x - x;
+//            double distanceY = closestPlayer.y - y;
+            double distanceZ = closestPlayer.z - z;
+
+            double distance = Math.hypot(distanceX, distanceZ);
+
+            waypointX = x + (distanceX / distance) * -5;
+            waypointY = y + 4;
+            waypointZ = z + (distanceZ / distance) * -5;
+        }
+
+        double distanceX = waypointX - x;
+        double distanceY = waypointY - y;
+        double distanceZ = waypointZ - z;
+
+        double distanceFromEntity = MathHelper.sqrt(distanceX * distanceX + distanceY * distanceY + distanceZ * distanceZ);
+
+        if (distanceFromEntity > 32) {
+            waypointX = x;
+            waypointY = y;
+            waypointZ = z;
+            return;
+        }
+
+        if (distanceFromEntity > 1D) {
+            xd += (distanceX / distanceFromEntity) * 0.01D;
+            yd += (distanceY / distanceFromEntity) * 0.01D;
+            zd += (distanceZ / distanceFromEntity) * 0.01D;
+            yRot = (float) ((Math.atan2(xd, zd) * 180F) / MathHelper.PI);
+        }
+
+        if(courseChangeCooldown-- <= 0) {
+            courseChangeCooldown += random.nextInt(40) + 20;
+            if (!(distanceFromEntity > 1D) || !isCourseTraversable(waypointX, waypointY, waypointZ, distanceFromEntity)) {
+                double nextX = x + (double) ((random.nextFloat() * 2.0F - 1.0F) * 16F);
+                double nextY = y + (double) ((random.nextFloat() * 2.0F - 1.0F) * 5F);
+                double nextZ = z + (double) ((random.nextFloat() * 2.0F - 1.0F) * 16F);
+
+                if (nextY > y) {
+                    if (isUpwardWaypointValid(MathHelper.floor(nextX), MathHelper.floor(nextY), MathHelper.floor(nextZ))) {
+                        waypointX = nextX;
+                        waypointY = nextY;
+                        waypointZ = nextZ;
+                    } else {
+                        waypointX = x;
+                        waypointY = y;
+                        waypointZ = z;
+                    }
+                } else {
+                    waypointX = nextX;
+                    waypointY = nextY;
+                    waypointZ = nextZ;
+                }
+            } /*else {
+                xd += (distanceX / distanceFromEntity) * 0.1D;
+                yd += (distanceY / distanceFromEntity) * 0.1D;
+                zd += (distanceZ / distanceFromEntity) * 0.1D;
+                yRot = (float) ((Math.atan2(xd, zd) * 180F) / MathHelper.PI);
+            }*/
+        }
+    }
+
+    public boolean isUpwardWaypointValid(int x, int y, int z) {
+        final byte range = 3;
+        for (int _y = y; _y > y - range; _y--) {
+            Block<?> block = world.getBlock(x, _y, z);
+            if (block == null/* || !block.hasTag(BlockTags.PASSIVE_MOBS_SPAWN)*/) continue;
+            return true;
+        }
+        return false;
+    }
+
+    public int getColor() {
+        return entityData.getByte(DATA_COLOR_ID) & 0xFF;
+    }
+
+    public void setColor(int color) {
+        assert color >= 0 && color <= 0xFF : "Color is outside valid range!";
+        entityData.set(DATA_COLOR_ID, (byte)color);
+    }
+
+    @Override
+    public void addAdditionalSaveData(CompoundTag tag) {
+        super.addAdditionalSaveData(tag);
+        tag.putByte("Color", (byte) getColor());
+    }
+
+    @Override
+    public void readAdditionalSaveData(CompoundTag tag) {
+        super.readAdditionalSaveData(tag);
+        setColor(tag.getByte("Color") & 0xFF);
+    }
+
+    @Override
+    public String getEntityTexture() {
+        String basePath = String.format("/assets/%s/textures/entity/%s/", textureIdentifier.namespace, textureIdentifier.value);
+        return basePath + getTextureReference() + "_0.png";
+//        if ((tickCount / 10) % 2 == 0) {
+//            return basePath + getTextureReference() + "_0.png";
+//        } else {
+//            return basePath + getTextureReference() + "_1.png";
+//        }
+    }
+
+    @Override
+    public String getTextureReference() {
+        SkinVariantList variantList = Global.accessor.getSkinVariantList();
+        String basePath = String.format("/assets/%s/textures/entity/%s/", textureIdentifier.namespace, textureIdentifier.value);
+        return colorEntries.get(getColor()).name + "/" + variantList.getSkinReference(basePath + "variants.json", "0", getSkinVariant());
+    }
+
+    public static class ButterflyEntry {
+        public final int id;
+        public final String name;
+        /** Biomes which the color can appear, null indicates any biome*/
+        private @Nullable Set<Biome> allowedBiomes;
+        public final Supplier<Item> jarItem;
+        public final double weight;
+
+        public ButterflyEntry(int id, String name, double weight, Supplier<Item> jarItem, Biome ... allowedBiomes) {
+            this.id = id;
+            this.name = name;
+            this.weight = weight;
+            this.jarItem = jarItem;
+
+            if (allowedBiomes.length > 0) {
+                this.allowedBiomes = new HashSet<>();
+                this.allowedBiomes.addAll(Arrays.asList(allowedBiomes));
+            }
+        }
+
+        public ButterflyEntry addAllowedBiome(Biome biome) {
+            if (allowedBiomes == null) allowedBiomes = new HashSet<>();
+            this.allowedBiomes.add(biome);
+            return this;
+        }
+
+        public ButterflyEntry removeAllowedBiome(Biome biome) {
+            if (allowedBiomes == null) allowedBiomes = new HashSet<>();
+            this.allowedBiomes.remove(biome);
+            return this;
+        }
+
+        public ButterflyEntry allowAllBiomes() {
+            this.allowedBiomes = null;
+            return this;
+        }
+
+        public boolean isBiomeAllowed(Biome biome) {
+            return allowedBiomes == null || allowedBiomes.contains(biome);
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index 5bec715fd..cfc4e51e6 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -4,6 +4,7 @@ import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.MobFlying;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileFireball;
+import net.minecraft.core.entity.vehicle.MobGhastVehicle;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.entity.Entity;
@@ -149,6 +150,9 @@ public class MobGhast extends MobFlying
             {
             	targetedEntity = null;
             }
+            if (targetedEntity != null && targetedEntity.vehicle instanceof MobGhastVehicle) {
+                targetedEntity = null;
+            }
             if(targetedEntity != null)
             {
                 aggroCooldown = 20;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
new file mode 100644
index 000000000..e73ef804b
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
@@ -0,0 +1,130 @@
+package net.minecraft.core.entity.monster;
+
+import com.mojang.nbt.tags.ByteTag;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.core.entity.IArmorWearing;
+import net.minecraft.core.enums.IArmorShape;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public abstract class MobMonsterArmored<T extends IArmorShape> extends MobMonster implements IArmorWearing<T> {
+    private static final int DATA_ARMOR_START = 24;
+
+    public MobMonsterArmored(final @Nullable World world) {
+        super(world);
+    }
+
+    @Override
+    protected void defineSynchedData() {
+        super.defineSynchedData();
+        for (int i = 0; i < getNumArmorSlots(); i++) {
+            this.entityData.define(DATA_ARMOR_START + i, null, ItemStack.class);
+        }
+    }
+
+    @Override
+    public @Nullable ItemStack getItemInArmorSlot(final @NotNull T slot) {
+        return this.entityData.getItemStack(DATA_ARMOR_START + slot.getSlotIndex());
+    }
+
+    @Override
+    public void setItemInArmorSlot(final @NotNull T slot, @Nullable ItemStack item) {
+        this.entityData.set(DATA_ARMOR_START + slot.getSlotIndex(), item);
+    }
+
+    @Override
+    public void addAdditionalSaveData(@NotNull CompoundTag tag) {
+        super.addAdditionalSaveData(tag);
+
+        final @NotNull ListTag list = new ListTag();
+        for (int i = 0; i < getNumArmorSlots(); i++) {
+            final @Nullable T slot = getArmorSlotByIndex(i);
+            if (slot != null) {
+                final @Nullable ItemStack itemInSlot = getItemInArmorSlot(slot);
+                if (itemInSlot != null) {
+                    final @NotNull CompoundTag armorTag = new CompoundTag();
+                    armorTag.putByte("Slot", (byte) i);
+                    itemInSlot.writeToNBT(armorTag);
+                    list.addTag(armorTag);
+                }
+            }
+        }
+        tag.putList("Armor", list);
+    }
+
+    @Override
+    public void readAdditionalSaveData(@NotNull CompoundTag tag) {
+        super.readAdditionalSaveData(tag);
+
+        final @Nullable ListTag list = tag.getList("Armor");
+        if (list != null) {
+            for (Tag<?> t : list) {
+                if (t instanceof CompoundTag) {
+                    final @NotNull CompoundTag ct = (CompoundTag) t;
+                    final @Nullable Tag<?> t2 = ct.getTag("Slot");
+                    if (t2 instanceof ByteTag) {
+                        final @Nullable T armorSlot = getArmorSlotByIndex(((ByteTag) t2).getValue());
+                        if (armorSlot != null) {
+                            final @Nullable ItemStack stack = ItemStack.readItemStackFromNbt(ct);
+                            if (stack != null) {
+                                setItemInArmorSlot(armorSlot, stack);
+                            }
+                        }
+                    }
+                }
+            }
+        }
+    }
+
+    @Override
+    protected void damageEntity(int damage, DamageType damageType) {
+        float protection = 1.0f;
+        if (damageType != null) {
+            protection -= getTotalProtectionAmount(damageType);
+        }
+        protection = Math.max(protection, 0.01f);
+
+        //If you take little damage and have lots of protection against that damage
+        //there is a high change you won't take any damage
+        double d = damage * protection;
+        int newDamage = (int) (random.nextFloat() > 0.5 ? Math.floor(d) : Math.ceil(d));
+
+        int preventedDamage = damage - newDamage;
+        if(damageType != null && damageType.shouldDamageArmor()){
+            //Reduce armor for big damage amounts, for example explosions
+            int armorDamage = (int) Math.ceil(preventedDamage / 4.0);
+            damageArmor(armorDamage);
+        }
+
+        super.damageEntity(damage, damageType);
+    }
+
+    @Override
+    public void lavaHurt() {
+        if(!fireImmune)
+        {
+            float protection = 1.0f - getTotalProtectionAmount(DamageType.FIRE);
+            protection = Math.max(protection, 0.01f);
+            hurt(null, 4, DamageType.FIRE);
+            remainingFireTicks = (int) (80 + 520 * protection);
+            maxFireTicks = remainingFireTicks;
+        }
+    }
+
+    @Override
+    public void fireHurt() {
+        if(!fireImmune)
+        {
+            float protection = 1.0f - getTotalProtectionAmount(DamageType.FIRE);
+            protection = Math.max(protection, 0.01f);
+            hurt(null, 1, DamageType.FIRE);
+            remainingFireTicks = (int) (40 + 260 * protection);
+            maxFireTicks = remainingFireTicks;
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
index bed83081e..b9b827d80 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
@@ -3,8 +3,11 @@ package net.minecraft.core.entity.monster;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
+import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.tags.CompoundTag;
@@ -12,18 +15,72 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
-public class MobSkeleton extends MobMonster
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Random;
+
+public class MobSkeleton extends MobMonsterArmored<HumanArmorShape>
 {
     public static final int DATA_ATTACK_TIME = 15;
 
-    public MobSkeleton(World world)
-    {
+    public MobSkeleton(World world) {
         super(world);
         textureIdentifier = new NamespaceID("minecraft", "skeleton");
         scoreValue = 500;
         mobDrops.add(new WeightedRandomLootObject(Items.AMMO_ARROW.getDefaultStack(), 0, 2));
         mobDrops.add(new WeightedRandomLootObject(Items.BONE.getDefaultStack(), 0, 2));
+
+        Map<ArmorMaterial, Map<HumanArmorShape, Item>> itemsMapMap = new HashMap<>();
+
+        Map<HumanArmorShape, Item> itemsMap = new HashMap<>();
+        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_LEATHER);
+        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_LEATHER);
+        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_LEATHER);
+        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_LEATHER);
+        itemsMapMap.put(ArmorMaterial.LEATHER, itemsMap);
+
+        itemsMap = new HashMap<>();
+        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_IRON);
+        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_IRON);
+        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_IRON);
+        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_IRON);
+        itemsMapMap.put(ArmorMaterial.IRON, itemsMap);
+
+        itemsMap = new HashMap<>();
+        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_GOLD);
+        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_GOLD);
+        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_GOLD);
+        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_GOLD);
+        itemsMapMap.put(ArmorMaterial.GOLD, itemsMap);
+
+        itemsMap = new HashMap<>();
+        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_CHAINMAIL);
+        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_CHAINMAIL);
+        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_CHAINMAIL);
+        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_CHAINMAIL);
+        itemsMapMap.put(ArmorMaterial.CHAINMAIL, itemsMap);
+
+        itemsMap = new HashMap<>();
+        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_DIAMOND);
+        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_DIAMOND);
+        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_DIAMOND);
+        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_DIAMOND);
+        itemsMapMap.put(ArmorMaterial.DIAMOND, itemsMap);
+
+        itemsMap = new HashMap<>();
+        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_STEEL);
+        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_STEEL);
+        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_STEEL);
+        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_STEEL);
+        itemsMapMap.put(ArmorMaterial.STEEL, itemsMap);
+
+        Random rand = new Random();
+        for (HumanArmorShape shape : HumanArmorShape.values()) {
+            ArmorMaterial mat = ArmorMaterial.getArmorMaterials().get(rand.nextInt(ArmorMaterial.getArmorMaterials().size()));
+            setItemInArmorSlot(shape, new ItemStack(itemsMapMap.get(mat).get(shape)));
+        }
     }
 
     @Override
@@ -97,26 +154,28 @@ public class MobSkeleton extends MobMonster
     }
 
     @Override
-	public void addAdditionalSaveData(@NotNull CompoundTag tag)
+	public ItemStack getHeldItem()
     {
-        super.addAdditionalSaveData(tag);
+        return defaultHeldItem;
     }
 
     @Override
-	public void readAdditionalSaveData(@NotNull CompoundTag tag)
-    {
-        super.readAdditionalSaveData(tag);
+    public int getNumArmorSlots() {
+        return HumanArmorShape.values().length;
     }
 
     @Override
-	public ItemStack getHeldItem()
-    {
-        return defaultHeldItem;
+    public @Nullable HumanArmorShape getArmorSlotByIndex(int index) {
+        if (index < 0 || index >= HumanArmorShape.values().length) {
+            return null;
+        }
+
+        return HumanArmorShape.values()[index];
     }
 
     private static final ItemStack defaultHeldItem;
 
-    static 
+    static
     {
         defaultHeldItem = new ItemStack(Items.TOOL_BOW, 1);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
index 92a769a7c..cd9d8345e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
@@ -1,24 +1,84 @@
 package net.minecraft.core.entity.monster;
 
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
-public class MobZombie extends MobMonster
-{
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Random;
 
-    public MobZombie(World world)
-    {
+public class MobZombie extends MobMonsterArmored<HumanArmorShape>
+{
+    public MobZombie(final World world) {
         super(world);
         textureIdentifier = new NamespaceID("minecraft", "zombie");
         moveSpeed = 0.5F;
         attackStrength = 5;
         scoreValue = 300;
         mobDrops.add(new WeightedRandomLootObject(Items.CLOTH.getDefaultStack(), 0, 2));
+
+        Map<ArmorMaterial, Map<HumanArmorShape, Item>> itemsMapMap = new HashMap<>();
+
+        Map<HumanArmorShape, Item> itemsMap = new HashMap<>();
+        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_LEATHER);
+        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_LEATHER);
+        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_LEATHER);
+        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_LEATHER);
+        itemsMapMap.put(ArmorMaterial.LEATHER, itemsMap);
+
+        itemsMap = new HashMap<>();
+        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_IRON);
+        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_IRON);
+        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_IRON);
+        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_IRON);
+        itemsMapMap.put(ArmorMaterial.IRON, itemsMap);
+
+        itemsMap = new HashMap<>();
+        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_GOLD);
+        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_GOLD);
+        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_GOLD);
+        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_GOLD);
+        itemsMapMap.put(ArmorMaterial.GOLD, itemsMap);
+
+        itemsMap = new HashMap<>();
+        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_CHAINMAIL);
+        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_CHAINMAIL);
+        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_CHAINMAIL);
+        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_CHAINMAIL);
+        itemsMapMap.put(ArmorMaterial.CHAINMAIL, itemsMap);
+
+        itemsMap = new HashMap<>();
+        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_DIAMOND);
+        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_DIAMOND);
+        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_DIAMOND);
+        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_DIAMOND);
+        itemsMapMap.put(ArmorMaterial.DIAMOND, itemsMap);
+
+        itemsMap = new HashMap<>();
+        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_STEEL);
+        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_STEEL);
+        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_STEEL);
+        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_STEEL);
+        itemsMapMap.put(ArmorMaterial.STEEL, itemsMap);
+
+        Random rand = new Random();
+        for (HumanArmorShape shape : HumanArmorShape.values()) {
+            ArmorMaterial mat = ArmorMaterial.getArmorMaterials().get(rand.nextInt(ArmorMaterial.getArmorMaterials().size()));
+            setItemInArmorSlot(shape, new ItemStack(itemsMapMap.get(mat).get(shape)));
+        }
     }
 
     @Override
@@ -55,4 +115,16 @@ public class MobZombie extends MobMonster
         return "mob.zombiedeath";
     }
 
+    @Override
+    public int getNumArmorSlots() {
+        return HumanArmorShape.values().length;
+    }
+
+    @Override
+    public @Nullable HumanArmorShape getArmorSlotByIndex(final int index) {
+        if (index < 0 || index >= HumanArmorShape.values().length) {
+            return null;
+        }
+        return HumanArmorShape.values()[index];
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java
index 124ae1261..035051a6f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java
@@ -55,6 +55,7 @@ public class MobZombieArmored extends MobZombie
 
     @Override
     public void defineSynchedData(){
+        super.defineSynchedData();
         entityData.define(DATA_BREAK_POINTS, 0, Integer.class);
         entityData.define(DATA_BREAK_ORDER, (short) 0, Short.class);
         entityData.define(DATA_GENERIC_FLAGS, (byte) 0, Byte.class);
